BeanDeserializer
Date: 2016-12-04

com.fasterxml.jackson.databind.deser

## Class BeanDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<java.lang.Object>
    - - com.fasterxml.jackson.databind.deser.BeanDeserializerBase
      - - com.fasterxml.jackson.databind.deser.BeanDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, ResolvableDeserializer, java.io.Serializable
  Direct Known Subclasses:
    ThrowableDeserializer

      public class BeanDeserializer
      extends BeanDeserializerBase
      implements java.io.Serializable

  Deserializer class that can deserialize instances of arbitrary bean objects, usually from JSON Object structs,
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.Exception` | `_nullFromCreator` Lazily constructed exception used as root cause if reporting problem with creator method that returns `null` (which is not allowed)

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

      `_anySetter, _arrayDelegateDeserializer, _backRefs, _beanProperties, _beanType, _delegateDeserializer, _externalTypeIdHandler, _ignorableProps, _ignoreAllUnknown, _injectables, _needViewProcesing, _nonStandardCreation, _objectIdReader, _propertyBasedCreator, _serializationShape, _subDeserializers, _unwrappedPropertyHandler, _valueInstantiator, _vanillaProcessing, TEMP_PROPERTY_NAME`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `BeanDeserializer(BeanDeserializerBase src)` Copy-constructor that can be used by sub-classes to allow copy-on-write style copying of settings of an existing instance.
    `` | `BeanDeserializer(BeanDeserializerBase src, BeanPropertyMap props)`
    `protected` | `BeanDeserializer(BeanDeserializerBase src, boolean ignoreAllUnknown)`
    `protected` | `BeanDeserializer(BeanDeserializerBase src, NameTransformer unwrapper)`
    `` | `BeanDeserializer(BeanDeserializerBase src, ObjectIdReader oir)`
    `` | `BeanDeserializer(BeanDeserializerBase src, java.util.Set<java.lang.String> ignorableProps)`
    `` | `BeanDeserializer(BeanDeserializerBuilder builder, BeanDescription beanDesc, BeanPropertyMap properties, java.util.Map<java.lang.String,SettableBeanProperty> backRefs, java.util.HashSet<java.lang.String> ignorableProps, boolean ignoreAllUnknown, boolean hasViews)` Constructor used by `BeanDeserializerBuilder`.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.lang.Exception` | `_creatorReturnedNullException()` Helper method for getting a lazily construct exception to be reported to `DeserializationContext.handleInstantiationProblem(Class, Object, Throwable)`.
    `protected java.lang.Object` | `_deserializeOther(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, com.fasterxml.jackson.core.JsonToken t)`
    `protected java.lang.Object` | `_deserializeUsingPropertyBased(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters.
    `protected java.lang.Object` | `_deserializeWithErrorWrapping(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, SettableBeanProperty prop)`
    `protected java.lang.Object` | `_missingToken(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Deprecated.
    `protected BeanDeserializerBase` | `asArrayDeserializer()` Fluent factory for creating a variant that can handle POJO output as a JSON Array.
    `java.lang.Object` | `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Main deserialization method for bean-based objects (POJOs).
    `java.lang.Object` | `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object bean)` Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.
    `protected java.lang.Object` | `deserializeFromNull(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Helper method called for rare case of pointing to `JsonToken.VALUE_NULL` token.
    `java.lang.Object` | `deserializeFromObject(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` General version used when handling needs more advanced features.
    `protected java.lang.Object` | `deserializeUsingPropertyBasedWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
    `protected java.lang.Object` | `deserializeUsingPropertyBasedWithUnwrapped(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
    `protected java.lang.Object` | `deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
    `protected java.lang.Object` | `deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object bean)`
    `protected java.lang.Object` | `deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method called when there are declared "unwrapped" properties which need special handling
    `protected java.lang.Object` | `deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object bean)`
    `protected java.lang.Object` | `deserializeWithView(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object bean, java.lang.Class<?> activeView)`
    `JsonDeserializer<java.lang.Object>` | `unwrappingDeserializer(NameTransformer unwrapper)` Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.
    `BeanDeserializerBase` | `withBeanProperties(BeanPropertyMap props)` Mutant factory method that custom sub-classes must override; not left as abstract to prevent more drastic backwards compatibility problems.
    `BeanDeserializer` | `withIgnorableProperties(java.util.Set<java.lang.String> ignorableProps)`
    `BeanDeserializer` | `withObjectIdReader(ObjectIdReader oir)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.BeanDeserializerBase

      `_convertObjectId, _findSubclassDeserializer, _handleTypedObjectId, _resolvedObjectIdProperty, _resolveInnerClassValuedProperty, _resolveManagedReferenceProperty, _resolveUnwrappedProperty, createContextual, creatorProperties, deserializeFromArray, deserializeFromBoolean, deserializeFromDouble, deserializeFromEmbedded, deserializeFromNumber, deserializeFromObjectId, deserializeFromObjectUsingNonDefault, deserializeFromString, deserializeWithObjectId, deserializeWithType, findBackReference, findConvertingDeserializer, findProperty, findProperty, findProperty, getBeanClass, getKnownPropertyNames, getObjectIdReader, getPropertyCount, getValueInstantiator, getValueType, handledType, handleIgnoredProperty, handlePolymorphic, handleUnknownProperties, handleUnknownProperty, handleUnknownVanilla, hasProperty, hasViews, injectValues, isCachable, properties, replaceProperty, resolve, wrapAndThrow, wrapAndThrow, wrapInstantiationProblem`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_coerceIntegral, _deserializeFromEmpty, _failDoubleToIntCoercion, _hasTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _parseBoolean, _parseBooleanFromInt, _parseBooleanFromOther, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, getValueClass, handleMissingEndArrayForSingle, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `getDelegatee, getEmptyValue, getEmptyValue, getNullValue, getNullValue, replaceDelegatee`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _nullFromCreator

          protected transient java.lang.Exception _nullFromCreator

      Lazily constructed exception used as root cause if reporting problem with creator method that returns `null` (which is not allowed)
      Since:
        3.8

  - ### Constructor Detail

    - #### BeanDeserializer

          public BeanDeserializer(BeanDeserializerBuilder builder,
                          BeanDescription beanDesc,
                          BeanPropertyMap properties,
                          java.util.Map<java.lang.String,SettableBeanProperty> backRefs,
                          java.util.HashSet<java.lang.String> ignorableProps,
                          boolean ignoreAllUnknown,
                          boolean hasViews)

      Constructor used by `BeanDeserializerBuilder`.

    - #### BeanDeserializer

          protected BeanDeserializer(BeanDeserializerBase src)

      Copy-constructor that can be used by sub-classes to allow copy-on-write style copying of settings of an existing instance.

    - #### BeanDeserializer

          protected BeanDeserializer(BeanDeserializerBase src,
                          boolean ignoreAllUnknown)

    - #### BeanDeserializer

          protected BeanDeserializer(BeanDeserializerBase src,
                          NameTransformer unwrapper)

    - #### BeanDeserializer

          public BeanDeserializer(BeanDeserializerBase src,
                          ObjectIdReader oir)

    - #### BeanDeserializer

          public BeanDeserializer(BeanDeserializerBase src,
                          java.util.Set<java.lang.String> ignorableProps)

    - #### BeanDeserializer

          public BeanDeserializer(BeanDeserializerBase src,
                          BeanPropertyMap props)

  - ### Method Detail

    - #### unwrappingDeserializer

          public JsonDeserializer<java.lang.Object> unwrappingDeserializer(NameTransformer unwrapper)

      Description copied from class: `JsonDeserializer`
      Method that will return deserializer instance that is able to handle "unwrapped" value instances If no unwrapped instance can be constructed, will simply return this object as-is.

      Default implementation just returns 'this' indicating that no unwrapped variant exists

      Specified by:
        `unwrappingDeserializer` in class `BeanDeserializerBase`

    - #### withObjectIdReader

          public BeanDeserializer withObjectIdReader(ObjectIdReader oir)

      Specified by:
        `withObjectIdReader` in class `BeanDeserializerBase`

    - #### withIgnorableProperties

          public BeanDeserializer withIgnorableProperties(java.util.Set<java.lang.String> ignorableProps)

      Specified by:
        `withIgnorableProperties` in class `BeanDeserializerBase`

    - #### withBeanProperties

          public BeanDeserializerBase withBeanProperties(BeanPropertyMap props)

      Description copied from class: `BeanDeserializerBase`
      Mutant factory method that custom sub-classes must override; not left as abstract to prevent more drastic backwards compatibility problems.
      Overrides:
        `withBeanProperties` in class `BeanDeserializerBase`

    - #### asArrayDeserializer

          protected BeanDeserializerBase asArrayDeserializer()

      Description copied from class: `BeanDeserializerBase`
      Fluent factory for creating a variant that can handle POJO output as a JSON Array. Implementations may ignore this request if no such input is possible.
      Specified by:
        `asArrayDeserializer` in class `BeanDeserializerBase`

    - #### deserialize

          public java.lang.Object deserialize(com.fasterxml.jackson.core.JsonParser p,
                                     DeserializationContext ctxt)
                                       throws java.io.IOException

      Main deserialization method for bean-based objects (POJOs).
      Specified by:
        `deserialize` in class `JsonDeserializer<java.lang.Object>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `java.io.IOException`

    - #### _deserializeOther

          protected final java.lang.Object _deserializeOther(com.fasterxml.jackson.core.JsonParser p,
                                           DeserializationContext ctxt,
                                           com.fasterxml.jackson.core.JsonToken t)
                                                      throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _missingToken

          @Deprecated
          protected java.lang.Object _missingToken(com.fasterxml.jackson.core.JsonParser p,
                                                  DeserializationContext ctxt)
                                            throws java.io.IOException

      Deprecated.
      Throws:
        `java.io.IOException`

    - #### deserialize

          public java.lang.Object deserialize(com.fasterxml.jackson.core.JsonParser p,
                                     DeserializationContext ctxt,
                                     java.lang.Object bean)
                                       throws java.io.IOException

      Secondary deserialization method, called in cases where POJO instance is created as part of deserialization, potentially after collecting some or all of the properties to set.
      Overrides:
        `deserialize` in class `JsonDeserializer<java.lang.Object>`
      Throws:
        `java.io.IOException`

    - #### deserializeFromObject

          public java.lang.Object deserializeFromObject(com.fasterxml.jackson.core.JsonParser p,
                                               DeserializationContext ctxt)
                                                 throws java.io.IOException

      General version used when handling needs more advanced features.
      Specified by:
        `deserializeFromObject` in class `BeanDeserializerBase`
      Throws:
        `java.io.IOException`

    - #### _deserializeUsingPropertyBased

          protected java.lang.Object _deserializeUsingPropertyBased(com.fasterxml.jackson.core.JsonParser p,
                                                        DeserializationContext ctxt)
                                                             throws java.io.IOException

      Method called to deserialize bean using "property-based creator": this means that a non-default constructor or factory method is called, and then possibly other setters. The trick is that values for creator method need to be buffered, first; and due to non-guaranteed ordering possibly some other properties as well.
      Specified by:
        `_deserializeUsingPropertyBased` in class `BeanDeserializerBase`
      Throws:
        `java.io.IOException`

    - #### _deserializeWithErrorWrapping

          protected final java.lang.Object _deserializeWithErrorWrapping(com.fasterxml.jackson.core.JsonParser p,
                                                       DeserializationContext ctxt,
                                                       SettableBeanProperty prop)
                                                                  throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### deserializeFromNull

          protected java.lang.Object deserializeFromNull(com.fasterxml.jackson.core.JsonParser p,
                                             DeserializationContext ctxt)
                                                  throws java.io.IOException

      Helper method called for rare case of pointing to `JsonToken.VALUE_NULL` token. While this is most often an erroneous condition, there is one specific case with XML handling where polymorphic type with no properties is exposed as such, and should be handled same as empty Object.
      Throws:
        `java.io.IOException`
      Since:
        2.7

    - #### deserializeWithView

          protected final java.lang.Object deserializeWithView(com.fasterxml.jackson.core.JsonParser p,
                                             DeserializationContext ctxt,
                                             java.lang.Object bean,
                                             java.lang.Class<?> activeView)
                                                        throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### deserializeWithUnwrapped

          protected java.lang.Object deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser p,
                                                  DeserializationContext ctxt)
                                                       throws java.io.IOException

      Method called when there are declared "unwrapped" properties which need special handling
      Throws:
        `java.io.IOException`

    - #### deserializeWithUnwrapped

          protected java.lang.Object deserializeWithUnwrapped(com.fasterxml.jackson.core.JsonParser p,
                                                  DeserializationContext ctxt,
                                                  java.lang.Object bean)
                                                       throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### deserializeUsingPropertyBasedWithUnwrapped

          protected java.lang.Object deserializeUsingPropertyBasedWithUnwrapped(com.fasterxml.jackson.core.JsonParser p,
                                                                    DeserializationContext ctxt)
                                                                         throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### deserializeWithExternalTypeId

          protected java.lang.Object deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p,
                                                       DeserializationContext ctxt)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### deserializeWithExternalTypeId

          protected java.lang.Object deserializeWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p,
                                                       DeserializationContext ctxt,
                                                       java.lang.Object bean)
                                                            throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### deserializeUsingPropertyBasedWithExternalTypeId

          protected java.lang.Object deserializeUsingPropertyBasedWithExternalTypeId(com.fasterxml.jackson.core.JsonParser p,
                                                                         DeserializationContext ctxt)
                                                                              throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### _creatorReturnedNullException

          protected java.lang.Exception _creatorReturnedNullException()

      Helper method for getting a lazily construct exception to be reported to `DeserializationContext.handleInstantiationProblem(Class, Object, Throwable)`.
      Since:
        2.8